<template>
  <form class="form" @submit="create">
    <TextField
      id="username"
      v-model="username"
      :error="usernameError"
      label="نام کاربری"
      dark
      class="field" 
    />
    <TextField 
      v-model="name" 
      :error="nameError" 
      dark 
      inputType="text" 
      label="نام و نام خانوادگی" 
      id="name" 
      class="field" 
    />
    <TextField 
      v-model="email" 
      :error="emailError" 
      dark 
      inputType="email" 
      label="ایمیل" 
      id="email" 
      class="field" 
    />
    <TextField 
      v-model="phone" 
      :error="phoneError" 
      dark 
      inputType="tel" 
      label="شماره موبایل" 
      id="phone" 
      class="field" 
    />
    <TextField
      inputType="password"
      id="password"
      v-model="password"
      :error="passwordError"
      label="رمز عبور"
      dark
      class="field" 
    />
    <TextField
      inputType="password"
      id="password-confirmation"
      v-model="passwordConfirmation"
      :error="passwordConfirmationError"
      label="تکرار رمز عبور"
      dark
      class="field" 
    />
    <Select :options="roles" v-model="role" id="role" dark label="نوع حساب" no-empty class="field" />
    <Button 
      class="button" 
      color="primary" 
      type="contained" 
      @click.native="create" 
      :disabled="disabled">
      ثبت
    </Button>
  </form>
</template>

<script>
import TextField from "@/components/base/TextField";
import Button from "@/components/base/Button";
import Select from "@/components/base/Select";

export default {
  name: "CreateUerForm",
  components: {
    TextField,
    Button,
    Select
  },
  data() {
    return {
      username: '',
      password: '',
      passwordConfirmation: '',
      name: '',
      email: '',
      phone: '',
      role: {
        title: 'کاربر عادی'
      },
      roles: [{ title: 'مدیر', id: 1 }, { title: 'کاربر عادی', id: 2 }]
    }
  },
  methods: {
    create(e) {
      e.preventDefault();
      if (this.canCreate) {
        const data = {
          username: this.username,
          email: this.email,
          name: this.name,
          phone: this.phone,
          password: this.password,
          role: this.getRole
        }
        const token = this.$store.getters['auth/getToken'];
        this.$store.dispatch('auth/createUser', { data, token }).then(response => {
          if (response.status === 201) {
            this.$store.dispatch('notifications/push', {
              message: 'کاربر ایجاد شد.',
              light: true,
              type: 'success',
            });
            this.$emit('create');
          }
        }).catch(error => {
          if (error.response.status == 400) {
            this.$store.dispatch('notifications/push', {
              message: 'ایمیل یا نام کاربری تکراری می باشد.',
              type: 'error',
            });
          } else if (error.response.status === 404) {
             this.$store.dispatch('notifications/push', {
              message: 'ورودی های نامعتبر.',
              type: 'error',
            });
          } else {
            this.$store.dispatch('notifications/push', {
              message: "خطا در اتصال به سرور! لطفا دقایقی دیگر تلاش کنید.",
              type: "error",
            });
          }
        })
      } else {
        this.$store.dispatch('notifications/push', {
          message: "لطفا ورودی ها خود را کنترل کنید",
          type: "warning",
          light: true
        });
      }
    }
  },
  computed: {
    isFormVaild() {
      return this.usernameError 
        || this.nameError 
        || this.emailError 
        || this.phoneError
        || this.passwordError
        || this.passwordConfirmationError ? false : true;
    },
    isFormFilled() {
      return this.username
        && this.name
        && this.email
        && this.phone
        && this.password
        && this.passwordConfirmation ? true : false;
    },
    disabled() {
      return this.isFormFilled ? false : true;
    },
    canCreate() {
      return this.isFormFilled && this.isFormVaild ? true : false;
    },
    getRole() {
      return this.role.title === "مدیر" ? "admin" : "user";
    },
    usernameError() {
      const regex = /^[a-z0-9_-]{3,16}$/;
      if (this.username.length === 0) {
        return ""
      } else if (this.username.length < 3) {
        return "نام کاربری باید حداقل 3 کاراکتر باشد."  
      } else if (regex.test(this.username)) {
        return ""      
      }
      return "نام کاربری فقط می تواند متشکل از حروف انگلیسی و عدد باشد."
    },
    passwordError() {
      if (this.password.length < 5 && this.password.length !== 0) {
        return "رمز عبور باید حداقل 5 کاراکتر باشد."
      }
      return ""
    },
    passwordConfirmationError() {
      if (this.passwordConfirmation !== this.password && this.passwordConfirmation.length > 0) {
        return "رمز عبور وارد شده با قبلی تطابق ندارد.";
      }
      return ""
    },
    nameError() {
      const regex = /^[آ-ی ء چ]+$/;
      if (!this.name) {
        return "";
      } else if (!regex.test(this.name)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    emailError() {
      const regex = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      if (!this.email) {
        return "";
      } else if (!regex.test(this.email)) {
        return "ایمیل وارد شده معتبر نمی باشد!";
      } else {
        return "";
      }
    },
    phoneError() {
      const regex = /^(\+98|0)?9\d{9}$/;
      if (!this.phone) {
        return "";
      } else if (!regex.test(this.phone)) {
        return "شماره موبایل وارد شده معتبر نمی باشد!";
      } else {
        return "";
      }
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.button
  width 100%

.field
  margin-bottom $sm
</style>